# This file was auto-generated by Fern from our API Definition.

from ..core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .organizations.client import AsyncOrganizationsClient, OrganizationsClient
from .projects.client import AsyncProjectsClient, ProjectsClient
from .raw_client import AsyncRawEeClient, RawEeClient


class EeClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawEeClient(client_wrapper=client_wrapper)
        self.organizations = OrganizationsClient(client_wrapper=client_wrapper)

        self.projects = ProjectsClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawEeClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawEeClient
        """
        return self._raw_client


class AsyncEeClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawEeClient(client_wrapper=client_wrapper)
        self.organizations = AsyncOrganizationsClient(client_wrapper=client_wrapper)

        self.projects = AsyncProjectsClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawEeClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawEeClient
        """
        return self._raw_client
