# This file was auto-generated by Fern from our API Definition.

from ...core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .annotations.client import AnnotationsClient, AsyncAnnotationsClient
from .functions.client import AsyncFunctionsClient, FunctionsClient
from .raw_client import AsyncRawProjectsClient, RawProjectsClient
from .spans.client import AsyncSpansClient, SpansClient


class ProjectsClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawProjectsClient(client_wrapper=client_wrapper)
        self.annotations = AnnotationsClient(client_wrapper=client_wrapper)

        self.spans = SpansClient(client_wrapper=client_wrapper)

        self.functions = FunctionsClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawProjectsClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawProjectsClient
        """
        return self._raw_client


class AsyncProjectsClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawProjectsClient(client_wrapper=client_wrapper)
        self.annotations = AsyncAnnotationsClient(client_wrapper=client_wrapper)

        self.spans = AsyncSpansClient(client_wrapper=client_wrapper)

        self.functions = AsyncFunctionsClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawProjectsClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawProjectsClient
        """
        return self._raw_client
