# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic
import typing_extensions
from ..core.pydantic_utilities import IS_PYDANTIC_V2
from ..core.serialization import FieldMetadata
from ..core.unchecked_base_model import UncheckedBaseModel
from .environment_public import EnvironmentPublic
from .function_public import FunctionPublic


class DeploymentPublic(UncheckedBaseModel):
    """
    Deployment public model.
    """

    environment_uuid: str
    function_uuid: str
    project_uuid: typing.Optional[str] = None
    is_active: typing.Optional[bool] = None
    version_num: typing.Optional[int] = None
    notes: typing.Optional[str] = None
    activated_at: typing.Optional[dt.datetime] = pydantic.Field(default=None)
    """
    Timestamp when the deployment was activated.
    """

    uuid_: typing_extensions.Annotated[str, FieldMetadata(alias="uuid")]
    organization_uuid: str
    function: typing.Optional[FunctionPublic] = None
    environment: typing.Optional[EnvironmentPublic] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
