# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2
from ..core.unchecked_base_model import UncheckedBaseModel
from .common_call_params import CommonCallParams
from .dependency_info import DependencyInfo


class FunctionCreate(UncheckedBaseModel):
    """
    Function create model.
    """

    project_uuid: typing.Optional[str] = None
    version_num: typing.Optional[int] = None
    name: str
    signature: str
    code: str
    hash: str
    dependencies: typing.Optional[typing.Dict[str, DependencyInfo]] = None
    arg_types: typing.Optional[typing.Dict[str, str]] = None
    archived: typing.Optional[dt.datetime] = None
    custom_id: typing.Optional[str] = None
    prompt_template: typing.Optional[str] = None
    provider: typing.Optional[str] = None
    model: typing.Optional[str] = None
    call_params: typing.Optional[CommonCallParams] = None
    is_versioned: typing.Optional[bool] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
